#include "clearball.h"
#include "worldmodel.h"
#include "skill.h"
#include "agent.h"

bool ClearBall::Clear_Ball(Command& command){
	float clearangle=GetClearAngle();
	if (FieldInfo.DirConf(clearangle)>0.85f)
	{
		if (Self.Is_goalie)
			Skill::kick.oakick(ball.max_speed *0.9f, clearangle, command, KK_fast); 
		else
		{
			float kicktospd = Skill::kick.smartkick(ball.max_speed,clearangle,command,KK_fast);
			if (kicktospd < 2.0f)
				return false;
		}
		lastclearangle = clearangle;
		return true;
	}
	else
		return false;
}

bool ClearBall::Clear_Ball(){
	Command command;
	bool success = Clear_Ball(command);
	if (success)
		Agent::mediator.enroll(command,Action_clear,PriorityA);
	return success;
}


float ClearBall::GetClearAngle()
{
	int upangle, lowangle,tempangle;
	if (Self.pos.y>ServerParam::goal_width/2)
	{
		upangle = 0;
		lowangle = 90;
	}
	else if (Self.pos.y <-ServerParam::goal_width/2)
	{
		upangle =-90;
		lowangle = 0;
	}
	else
	{
		upangle = -60;
		lowangle = 60;
	}
	float clearangle = 0,clearvalue = 0,tmpvalue = 0;
	tempangle = upangle;
	do{
		tmpvalue = clearsuccessvalue((float)tempangle) * usefulness((float)tempangle) * FieldInfo.DirConf((float)tempangle);
		if (tmpvalue > clearvalue){
			clearangle = (float)tempangle;
			clearvalue = tmpvalue;
		}
		tempangle += (int)ClientParam::goalie_clear_search_ang;
	}while(tempangle < lowangle);
	return clearangle;
}

float ClearBall::usefulness(float ang)
{
	return 0.5f * (Sin(1.5f * (float)fabs(ang) + 45.0f) + 1);
}

float ClearBall::clearsuccessvalue(float ang)
{
	float value = 1;
	float w,d;
	Line angline;
	Vector projectpoint;
	Vector OPos;
	angline.LineFromRay(Self.pos,ang);
	int i;
	for(i = 0;i<FieldInfo.Num_TheirVisiblePlayers(); i++){ 
		OPos = FieldInfo.TheirPlayer_Close2Me(i).pos;
		if (Angle_between(NormalizeAngle((OPos - Self.pos).Angle()),NormalizeAngle(ang - ClientParam::goalie_clear_ang),NormalizeAngle(ang + ClientParam::goalie_clear_ang))){
			projectpoint = angline.ProjectPoint(OPos);
			w = OPos.dist(projectpoint);
			d = Self.pos.dist(projectpoint);
			value *= w/d;
		}
	}
	return value;
}

AngleDeg ClearBall::GetLastClearBallAngle(){
	return lastclearangle;
}

