#ifndef __CLIENTPARAM_H__
#define __CLIENTPARAM_H__

#include "types.h"

const int CP_num_divisions = 48;
const int CP_MaxLines = 33;

class ClientParam  
{
public:
	ClientParam();
	virtual ~ClientParam();

	static int  clang_min_version;
	static int  clang_max_version;
/**************       Client  Params   *********************/
	static bool  goalie;
	static float  conf_max;
	static float  min_valid_conf;
	static float  min_ball_valid_conf;
	static float  conf_decay;

/*******      Log      ************/
	static int   log_max;
	static char	 logdir[100];
	static char  logfile[100];
	static char  recfile[100];
	static char  matfile[100];
	static char  pasfile[100];

	static char  CB_weightfile[100];
	static char  Sensitivity_weightfile[100];
	static char  Off_sen_weightfile[100];
	static char  FM_offense_weightfile[100];
	static char  FM_defense_weightfile[100];
	static char  DF_formation_priority_file[100]; 
	static char  DF_press_priority_file[100]; 
	static char  DF_Sensitivity_weightfile[100]; 
	static char  Mark_priority_weightfile[100]; 
	static char  Block_priority_weightfile[100]; 
	static char  deviation_weightfile[100]; 
	static char  playertype_file[100];
	static char  formation_file[100];
	static float  goalie_kick_min_vel;
	static float  deviation_max;  
	static int  setplay_wait_time;

/************************************/

	static int  Number;

/*********   Role   ********************/
	static float  attackness;
	static float  leftness;
	static float  aggressiveness;
	static float  creativeness;
/*************************/
	static char  appname[100];
/*************************/
	static float  reliable_kickarea;
	static float  desired_kickarea;
/***** turn ball ******************/
	static float  collision_buffer;
	static float  turnball_radius;
	static float  turnball_radius_threshold;
	static float  kickballaway_speed;
	static float  block_speed;
	static float  pos_deviation_max;
	static float  goto_allowed_error;
	static float  out_of_pitch_error;

	static int    decision_holdtime;
	static float  block_margin;
	static float  control_margin;
	static float  dribble_speed;
	static float  dribble_radius;
	static float  dribble_angle;
	static float  drweight_conf_a;
	static float  drweight_conf_b;
	static float  drweight_conf_c;
	static float  passweight_conf_a;
	static float  passweight_conf_b;
	static float  passweight_conf_c;
	static float  passable_angle;
	static float  passable_distance;
/*************** shoot  *******************/
	static float  max_shoot_distance;
	static float  goalie_catch_angle;
	static float  player_intercept_angle;
	static float  shoot_search_angle;
	static float  dribble_distance;
	static float  setplay_speed;
	static float  setplay_deviation;
	static float  defense_area_length;
	static float  defense_area_width;
	static float  block_speed_factor;
	static float  max_IT_cycles;
	static float  offeseposition_speed;
	static float  block_dist;
	static float  mark_dist;
	static float  check_dist;
	static float  mark_speed;
	static float  kick_threshold_factor;
	static float  mnmx_kickeffect;

	static float  goalie_safe_catch_length;
	static float  safecatch_width; 

/***************************************************/
	static float  goalie_clear_ang;
	static float  clear_angle;
	static float  goalie_clear_search_ang;
	static float  reliable_kickable_area;
	static float  powerkick_radius;
	static float  kickable_area;

	static float  collision_threshold;
/****************************************************/
	static float  too_different_distance;
	static float  identify_min_conf;
	static float  different_distance;
	static float  negativepower_factor;
	static float  collision_detected_threshold;
/****************************************************/
	static float  selfvel_mingap;
	static float  VW_Narrowfactor;
	static float  def_concern_area;

	static char  KickOA_weightfile_A[100];
	static char  KickOA_weightfile_B[100];
	static char  KickOA_weightfile_C[100];
	static char  KickOA_weightfile_D[100];
	static float  catcharea_compensation;

	static float  k_dribble_avoid;
	static float  k_dribble_rosen;
	static float  shoot_avoidgoalie;
/****************************************************/
	static float  Audio_player_fardist;

	static int MaxLines;
	static int MaxRows;
/**************************************************/
	static int num_divisions;			//ȵҰֵԪ
	static float division;


	static float impossible_speed;
	static float infinite_speed;

};


class FieldParam
{
public:
	FieldParam();
	static int FP_goalie_number;
	static int FP_theirgoalie_number;
	static float FP_attackness[SP_team_size];
	static float FP_leftness[SP_team_size];
	static float FP_aggressiveness[SP_team_size];
	static float FP_creativeness[SP_team_size];
};
#endif // _CLIENTPARAM_H
