#ifndef __GOINGTHROUGHSPEED_H__
#define __GOINGTHROUGHSPEED_H__


#include "types.h"
#include "geometry.h"

const float CP_kickarea_compensation = 0.7f;

class GT_speed_utils{
public:
	static void Initialize();

	static float calc_goingthroughspeed(Vector pos, float t);
	static float calc_goingthroughspeed(Ray& ballcourse, const Vector& opp, const Line& pline);
	static float calc_spottingspeed(Vector pos, float t, int addcycle = 1);
	static float calc_spottingspeed(Vector pos, float t, float& cycles, int addcycle = 1);	
	static float calc_peakpoint(Vector pos);
	static float calc_goalie_spottingspeed(Vector pos, float t);
	static float calc_goalie_goingthroughspeed(Vector pos, float t);
	static bool calc_interception_solution(Vector startpoint, float ballspeed, Vector& inf_sup);

	static unsigned char calc_interception_solution(const Vector& startpoint, float ballspeed, Vector* inf, bool onlyclosest = false);
	static Vector calc_closest_it_cycles(const Vector& startpoint, float ballspeed);
	static int get_closest_it_index(unsigned char state);

	static void set_intercept_param(float kickable_area, float player_max_speed);
	static float Player_Intercept_Speed();
	static float Player_kickable_area();

	static float kick_area;
	static float max_speed;
	static double log_ball_decay;
};

#endif //__GOINGTHROUGHSPEED_H__
