#ifndef __MOTION_H__
#define __MOTION_H__


#include "types.h"
#include "command.h"
/******            simple behaviors           *********/

class Behaviors  {
public:
	Behaviors();
	void Reset();

/*******************   basic behaviors ***************/
	static bool look_goto(Vector pos, float look_angle, float visual_width, float rapidness, float reverse_raipdness, Command& command);
	static bool look_goto(Vector pos, float look_angle, float visual_width, float rapidness, float reverse_raipdness);
	static bool go_to(Vector pos, float rapidness, Command& command);
	static bool go_to(Vector pos, float rapidness); // execute at once
	bool smartgoto(Vector pos, float speed);// execute at once
	bool smartgoto(Vector pos, float speed, Command& command);
	static AngleDeg turn_to(AngleDeg ang, Command& command);
	static AngleDeg turn_to(AngleDeg ang); // execute at once
	static AngleDeg turn_to(Vector pos, Command& command);
	static AngleDeg turn_to(Vector pos); // execute at once
	static bool smartturn(AngleDeg ang, Command& command);
	static bool smartturn(AngleDeg ang); // execute at once
	static AngleDeg turn_neck_to(AngleDeg ang, AngleDeg bdfy, Command& command);
	static AngleDeg turn_neck_to(AngleDeg ang, Command& command);
	static AngleDeg turn_neck_to(AngleDeg ang); // execute at once

	static bool run(float rapidness, Command& command);
	static bool run(float rapidness);  // execute at once
	static bool stay(Command& command);
	static bool stay();
	static bool donothing(Command& command);
	static bool donothing();
	static bool circumambulate(Vector pos, float rapidness);
	static bool circumambulate(Vector pos, float rapidness, Command& command);
};

#endif //__MOTION_H__
