#ifndef __PARAMREADERUTIL_H__
#define __PARAMREADERUTIL_H__

#include <vector>

//allowed param type
enum InputType{
	V_INT,		//int,		3
	V_FLOAT,	//float,	3.33
	V_BOOL,		//bool,		(true)/false
	V_STRING,	//char[],	abc
	V_ONOFF,	//bool,		(on)/off
	V_NONE
};

struct option_t {
	char	optname[50] ;
	void	*vptr ;
	InputType  vsize ;
};

class ParamReader{
private:
	std::vector<option_t> opt;
public:
	void ParseItem(const char * buf);
	ParamReader();

	void AddItem(option_t& item);
	void ResetItem();

	void GetOptions(const char * filename);
	void GetOptions(int argc, char** argv);
	void ParseOptions(const char *Info);

	void ReadString(const char** src, char* value);
};

#endif //__PARAMREADERUTIL_H__
