#ifndef __PITCH_H__
#define __PITCH_H__

#include "geometry.h"
#include "objects.h"
#include "serverparam.h"


class Pitch  
{
public:
	Pitch();
	void Initialize(bool rotate);
	Rect field;
	Rect marginfield;
	Rect l_field;
	Rect r_field;

	Rect theirfield;
	Rect myfield;

	Rect backfield;
	Rect forwardfield;
	Rect midfield;

	Rect l_backfield;
	Rect m_backfield;
	Rect r_backfield;

	Rect l_midfield;
	Rect m_midfield;
	Rect r_midfield;

	Rect l_forwardfield;
	Rect m_forwardfield;
	Rect r_forwardfield;

	Rect my_penaltyarea;
	Rect their_penaltyarea;
	Rect my_goaltenderbox;
	Rect their_goaltenderbox;
	Rect my_goaldefendbox; 

	Rect expanded_field;//greater than field
	Rect shrinked_field; //smaller than field

	Vector mygoal;
	Vector l_mygoalpost;
	Vector r_mygoalpost;
	Vector theirgoal;
	Vector l_theirgoalpost;
	Vector r_theirgoalpost;

	Line SideLines[4];
	Object Markers[SP_num_markers+1];
	Object Lines[SP_num_lines+1];

	inline bool WithInField(const Vector& pos){return field.IsWithin(pos);}
	inline bool WithInMarginField(const Vector& pos){return marginfield.IsWithin(pos);}
	inline bool WithInExpandedField(const Vector& pos){return expanded_field.IsWithin(pos);}
	inline bool WithInLeftField(const Vector& pos){return l_field.IsWithin(pos);}
	inline bool WithInRightField(const Vector& pos){return r_field.IsWithin(pos);}

	virtual ~Pitch();

};

#endif //__PITCH_H__
