#ifndef __POSITIONING_H__
#define __POSITIONING_H__

#include "types.h"
#include "df_positioning.h"
#include "command.h"

//position speed
const float CP_fast_formation_speed = 1.0f;
const float CP_mid_formation_speed = 0.7f; 
const float CP_mid_offense_speed = 0.5f;
const float CP_slow_formation_speed = 0.4f;

class PositionAction{
protected:
	Vector point;
	float  rapidness;
	float max_deviation;
	float priority;
	ActionType actiontype;
public:
	PositionAction();
	float GetPriority();	
	bool InvalidZoneAdjust(Vector& point);
	ActionType GetActionType(){ return actiontype;};
	void SetPositioningInfo(Vector point, float rapidness, float max_deviation, float priority, ActionType actiontype);
	void position();
};


class Positioning : public DF_positioning, public PositionAction{
private:
public:
	DF_Arrangement arrangement;
	TimedDataArray<DF_Arrangement, 3> logdefense;

	Positioning();
	
	bool RunPS();
	void Position();
	void Defense();
	void Offense();
	void OffensiveFormation();
	void DefensiveFormation();
	float GetDefenseSpeed(const DF_Arrangement & arrangement);
	void CloseBlock(DF_Arrangement &arrangement);
};

#endif //__POSITIONING_H__
